﻿// Copy Justification from Style to Stile
//  Скрипт считывает парамтры Justification с одного стиля и присваивает его другому, по вашему выбору
// Б. Кащеев, adobeindesign.ru, boriskasmoscow@gmail.com
#targetengine "copyJustification"
//#target indesign;
main();
function main()
{
 
    if(app.documents.length == 0){ 
        alert("Пожалуйста откройте документ и запустите скрипт снова");
        exit();
    }
    app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
    var myParaStyleNames = myGetParagraphStyleNames();
     myWin = myDialog(myParaStyleNames);
    var    res = myWin.show();
    if(res !=1) { exit(); }
     
} // main
function myDialog(myParaStyleList)
{
    var w = new Window("palette"," Копирование параметров Justification ");
    this.windowRef = myDialog;
    w.orientation = "column";
    w.alignChildren = "left";
    w.spacing = 20;
    w.margins = 20;
    w.add("statictext",undefined,"Скопировать Justification из стиля");
    myDrop1 = w.add("dropdownlist", undefined, myParaStyleList);
    myDrop1.titleLayout = { alignment: ['left', 'center'], spacing: 3, characters: 30, justify: 'left' };
    myDrop1.selection=0; //  
    myDrop1.preferredSize = [220, 20];
    w.add("statictext",undefined,"Присвоить скопированные параметры стилю");
    myDrop2 = w.add("dropdownlist", undefined, myParaStyleList);
    myDrop2.titleLayout = { alignment: ['left', 'center'], spacing: 3, characters: 30, justify: 'left' };
    myDrop2.selection=0; //  
    myDrop2.preferredSize = [220, 20];
    myGroup = w.add( "group" );
    myGroup.orientation = 'row';
    myGroup.cancelButton = myGroup.add( "button", undefined, "Отмена" );
    myGroup.okButton = myGroup.add( "button", undefined, "Выполнить" );
    myGroup.endButton = myGroup.add( "button", undefined, "Закончить" );
    myGroup.okButton.helpTip = "Оптимальные значения для русских текстов\
wordSpasing 95/100/125\
letterSpasing -5/0/5\
gliphScaling 98/100/102";    
    myGroup.okButton.onClick = function ()
        {
            sourceStyleName = myDrop1.selection.text;
            targetStyleName = myDrop2.selection.text;
            if( sourceStyleName != "[Не выбрано]" || targetStyleName != "[Не выбрано]" )
            { transferJustification() }
            else { alert("Стили не выбраны", "Copy Justification from Style to Style") }
       } 
   myGroup.endButton.onClick = function() { w= this.window.close( 1 ) }
   myGroup.cancelButton.onClick = function() { this.window.close( 0 ); }
   return w;
} // fnc

function transferJustification()
{
    sourceStyle = getParagraphStyleByName(sourceStyleName);
    targetStyle = getParagraphStyleByName(targetStyleName);
    
    targetStyle.maximumWordSpacing = sourceStyle.maximumWordSpacing;
    targetStyle.maximumLetterSpacing = sourceStyle.maximumLetterSpacing;
    targetStyle.maximumGlyphScaling = sourceStyle.maximumGlyphScaling;

    targetStyle.desiredWordSpacing  = sourceStyle.desiredWordSpacing;
    targetStyle.desiredLetterSpacing = sourceStyle.desiredLetterSpacing ;
    targetStyle.desiredGlyphScaling  = sourceStyle.desiredGlyphScaling;

    targetStyle.minimumWordSpacing = sourceStyle.minimumWordSpacing;
    targetStyle.minimumLetterSpacing = sourceStyle.minimumLetterSpacing ;
    targetStyle.minimumGlyphScaling = sourceStyle.minimumGlyphScaling;
    
    alert("Сделано !", "Copy Justification from Style to Style");
}


function myGetParagraphStyleNames()
{
var result = [];    
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
for(var i=0; i < myParagraphStyles.length ; i++)
{
    myParagraphStyleName = myParagraphStyles[i].name;
    obj = myParagraphStyles[i];
    while(obj.parent instanceof ParagraphStyleGroup)
    {
        myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
        obj = obj.parent;        
    }
    result.push(myParagraphStyleName);
 } // for
result.shift(); // удаление стиля No Paragraph Style
result.unshift("[Не выбрано]"); //  добавляем в начало массива имен новый пункт
return result;
} // fnc

function getParagraphStyleByName(myStyleName)
{
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
    for(var i=0; i < myParagraphStyles.length ; i++)
    {
        myParagraphStyleName = myParagraphStyles[i].name;
        obj = myParagraphStyles[i];
        while(obj.parent instanceof ParagraphStyleGroup)
        {
            myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
            obj = obj.parent;        
        }
        if(myParagraphStyleName == myStyleName)  return myParagraphStyles[i];
     } // for
    
} // fnc